/*==============================================================================
	Copyright (C) 2008 IT Access.,Co.Ltd. All Rights Reserved.
	
	This software is the confidential and proprietary information 
	of IT Access.,Co.Ltd.
		
	Note:

==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> INCLUDE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/
#ifdef	_WIN32
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#endif

#include "GealCommon.h"
#include "GealTypes.h"
#include "GealAPI.h"
#include "GealConfigAPI.h"
#include "GealUtilAPI.h"
#include "GealFigureAPI.h"
#include "GealStringAPI.h"
#include "GealTimerAPI.h"
#include "GealTargetAPI.h"
#include "GealLayerAPI.h"
#include "GealWidgetAPI.h"
#include "GealWRectAPI.h"
#include "GealWTextAPI.h"
#include "GealWButtonAPI.h"
#include "GealWPictureAPI.h"
#include "GealWGaugeAPI.h"
#include "GealWListAPI.h"
#include "GealWMenuAPI.h"
#include "GealWFigureAPI.h"

#include "GealRsxEnum.h"
#ifdef	_WIN32
	#include "TargetTypes.h"
#else	// Target
	#include "TargetKS\TargetTypes.h"
#endif



/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PRIVATE PROCEDURE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/



/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PUBLIC PROCEDURE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

/* -----------------------------------------------------------------------------
	This API initializes user application.
	[UAvP[V
------------------------------------------------------------------------------*/
GE_VOID UGxAppInitialize()
{
	HTARGET		hTarget = UGxTargetGet(0);
	
	/* Xe[W̐؊& ĕ` */
	GxStageChange(hTarget, eSTGID_Stage00, GE_TRUE);
}

/*------------------------------------------------------------------------------
	This API is periodic user application process.
	[UAvP[VC[v
------------------------------------------------------------------------------*/
GE_BOOL UGxAppProcess(GE_MSG* psMsg)
{
	HTARGET		hTarget = UGxTargetGet(0);

	if (psMsg->wMsg == eGEMSG_BUTTON_CLICK)
	{
			GxRenderUpdate(hTarget, GE_FALSE);
	}
	return GE_FALSE;
}

/*------------------------------------------------------------------------------
	This API finalizes user application.
	[UAvP[VI
------------------------------------------------------------------------------*/
GE_VOID UGxAppFinalize()
{

}

/*------------------------------------------------------------------------------
	This API is called in entering the stage.
	Stage Jn
------------------------------------------------------------------------------*/
GE_VOID UGxStageEnter(GE_ID eStageID)
{
}

/*------------------------------------------------------------------------------
	This API is called in exiting the stage.
	Stage I
------------------------------------------------------------------------------*/
GE_VOID UGxStageExit(GE_ID eStageID)
{
}

/*------------------------------------------------------------------------------
	This API called before redering the layer.
------------------------------------------------------------------------------*/
GE_BOOL UGxLayerRender(HTARGET hTarget,
					   GE_ID   eLayerID)
{
	return GE_FALSE;
}

/*------------------------------------------------------------------------------
	This API called before redering the widget.
------------------------------------------------------------------------------*/
GE_BOOL UGxWidgetRender(HTARGET  hTarget,
						GE_POINT sOffset,
						GE_ID    eWidgetID)
{
	return GE_FALSE;
}

/*------------------------------------------------------------------------------
	This API called before redering widget button by clicked.
------------------------------------------------------------------------------*/
GE_BOOL UGxButtonClickRender(HTARGET hTarget,
							 GE_ID   eWBtnID,
							 GE_BOOL bPushed)
{
	return GE_FALSE;	
}
