/********************************************************************
@t@C
	lcdlib.c

  
	Kenic system UNT3224-L30P ɓĂ KS-LETQ-2PpCu
	sample  LPC2388ɉC
	
	by Kou, IT-ACCESS
	2009/10/30

********************************************************************/
#include 		"lcdlib.h"

// LPC2388Bank0,1ɕĂ邽߁Af[^܂ꍇȏɂȂ邪A
// Interface11QlɁAjAANZXɉCB
// USE_BANK define OƁAʏBank܂

#ifdef	USE_BANK
	#define		LCD_OFFSET	0x80000000	// Original for datasheet of NXP
	#define		LCD_BANK0		LCD_OFFSET
	#define		LCD_BANK0_END	((unsigned char *)(LCD_OFFSET+0x0000ffff))

	#define		LCD_BANK1		((unsigned char *)(LCD_OFFSET+0x01000000))
	#define		LCD_BANK1_END	((unsigned char *)(LCD_OFFSET+0x0100ffff))

	#define		LCD_BANK01_OFFSET	(LCD_BANK1-(LCD_BANK0_END+1))
#else
	#define		LCD_OFFSET		0x80ff0000	// BankjAANZX邱Ƃ\
	#define		LCD_BANK0		LCD_OFFSET
	#define		LCD_BANK1		((unsigned char *)(LCD_OFFSET+0x01000000))
	#define		LCD_BANK01_OFFSET	0
#endif

#define		LCD_WIDTH	320
#define		LCD_HEIGHT	240
#define		LCD_LINEINT	512	//s

/*********************************************************************
	֐
		fnSetReg,fnSetBank
	
		ucData
	߂l
		Ȃ
	
		e탌WX^ANZX

**********************************************************************/
void	fnSetBank(unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1+0xfff8)= ucData;
}

void	fnSetReg1(unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1 + 0xfffc)= ucData;
}

void	fnSetReg2(unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1 + 0xfffd)= ucData;
}

void	fnSetReg3(unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1 + 0xfffb)= ucData;
}

void	fnSetReg4(unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1 + 0xfff9)= ucData;
}


/*********************************************************************
	֐
		touch_read(^b`plW擾@␳	)
	
		Ȃ
	߂l
		true = Ă false=ĂȂi0,0)
	
		^b`plWWX^ɓĂ̂ŁAǂ

**********************************************************************/
unsigned char touchx_read( void )
{
	return ( *(unsigned char *)(LCD_BANK1 + 0x0fffc)) ;

}

unsigned char touchy_read(void)
{
	return ( *(unsigned char *)(LCD_BANK1 + 0x0fffd)) ;
}

//
// Kenic ł̃^b`plON/OFF́A|[goR
// PORT2-11 ON=HI, OFF=LOWŏo邪AWADlWX^ɊmFĂ
//WADli[x,y](0,0)jłoȂ̂ŁAƂ肠͂ŁB

#define	TX_OFF	10
#define	TY_OFF	14

int touch_read(unsigned short *x, unsigned short *y)
{
	*x = touchx_read() ;
	*y = touchy_read() ;
	if ( *x | *y ) {
		*x =  *x  * LCD_WIDTH / (255-17) ;		// 256320MAXɕ␳iADlBYTÊ߁j
		if ( *x > TX_OFF ) *x -= TX_OFF ;

		*y =  *y  * 256 / 240 ;
		if ( *y > TY_OFF ) *y -= TY_OFF ;
		return 1 ;
	}
	return 0 ;
}

/*********************************************************************
	֐
		set_colormap
	
	߂l
		Ȃ
	
		J[pbgɏl

**********************************************************************/
void fnSetColorMap(unsigned char ucAdd, unsigned char ucData)
{
	*(unsigned char *)(LCD_BANK1 + 0xff00 + ucAdd)= ucData;
}

void set_default_colormap(void)
{
	unsigned int i;

	/*J[}bve[u֏l*/
	for( i=0; i<64; i++ ){
		fnSetColorMap( (unsigned char)(2*i),
			(unsigned char)(((i&0x03)<<2|(i&0x0c)<<4)|0x33) );
		fnSetColorMap( (unsigned char)(2*i+1),
			(unsigned char)(((i&0x30)>>2)|0x03) );
	}
	fnSetColorMap( 0, 0x00 );
	fnSetColorMap( 1, 0x00 );
}

/*********************************************************************
	֐
		cls(NAXN[)
	
		ucColor
	߂l
		Ȃ
	
		320~240hbg̑SGAw肵PFœhiNAj

**********************************************************************/
void cls( unsigned char ucColor )
{
	unsigned char	*lcdptr;
	lcdptr = (unsigned char *)LCD_BANK1 + 0xfffe;

	*lcdptr = ucColor;
	lcdptr++;
//	*lcdptr = 0xff;	// Write to Kick
	*lcdptr = ucColor;;	// Write to Kick
}


/*********************************************************************
	֐
		fnChkClsend(NAXN[҂)
	
		Ȃ
	߂l
		Ȃ
	
		cls()̏I҂

**********************************************************************/
#define	WAIT_CLR	0xff

void fnChkClsend(void)
{
	unsigned char	*lcdptr;
	unsigned char cCol;
	int i ;
	lcdptr = (unsigned char *)LCD_BANK1 +0xffff;

//	for(;;){
	for( i=0; i < WAIT_CLR; i++ ){
		cCol = *lcdptr;
		if((cCol & 0x01) == 0x00) break;
	}
}

#if 0	//NOUSE
#endif

/*********************************************************************
	֐
		cls2uCh(NAXN[)
	
		ucColor
	߂l
		Ȃ
	
		320~240hbg̑SGAw肵PFœhiNAj
		
**********************************************************************/
void cls2(unsigned char ucColor)
{
	unsigned int  uiY,uiN;

	for(uiN = 0; uiN < 20 ;uiN++ ){
		for(uiY = 0 ; uiY < 240 ; uiY+=20 ){
			fnLineX(uiY+uiN,ucColor);
		}
	}
}


/********************************************************************
	֐
		fnDot
	
		uiX,uiY: _x,yW
		cCol:hbg̕\F
	߂l
		Ȃ
	
		CӐFœ_ł

*********************************************************************/
void fnDot(unsigned int uiX,unsigned int uiY,unsigned char cCol)
{
//	ORG *(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) = cCol;

	register unsigned char *adr ;
	adr = 	(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) ;
#ifdef	USE_BANK
	if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif
	*adr = cCol ;
}

// 65536F[hABank0,1ؑւL,H2񏑂݁@gĂȂ
/*
void fnDotFullColor(unsigned int uiX,unsigned int uiY,unsigned char cColH,unsigned char cColL)
{
	fnSetReg2(0x01);
	*(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) = cColH;
	fnSetReg2(0x00);
	*(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) = cColL;
}
*/


// 65536F[hABank0,1ؑւL,H2񏑂݁@VK쐬@KOU
void fnDot16(unsigned int uiX,unsigned int uiY,unsigned short cCol)
{
	register unsigned char *adr ;
	adr = 	(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) ;
#ifdef	USE_BANK
	if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif

	fnSetReg2(0x01);
	*adr = (unsigned char)(cCol>>8) ;
	fnSetReg2(0x00);
	*adr = (unsigned char)(cCol&0xff) ;
}

/********************************************************************
	֐
		fnReadDot
	
		uiX,uiY: _x,yW
		cCol:hbg̕\F
	߂l
		char
	
		CӐFœ_ł

*********************************************************************/
unsigned char fnReadDot(unsigned int uiX,unsigned int uiY)
{
//	unsigned char cCol;
	register unsigned char *adr ;

	adr = 	(unsigned char *)( uiY * LCD_LINEINT + uiX + LCD_OFFSET) ;
#ifdef	USE_BANK
	if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif
	return(*adr) ;

//	cCol = *(unsigned char *)(uiY * LCD_LINEINT + uiX + LCD_OFFSET);	
//	return cCol;
}


/*********************************************************************
	֐
		fnLine
	
		(uiX1,uiY1)
		(uiX2,uiY2)
		ucC : F
	߂l
		Ȃ
	
		CӐFŎΐ

**********************************************************************/
void	fnLine(unsigned int uiX1,unsigned int uiY1,unsigned int uiX2,unsigned int uiY2,unsigned char ucC)
{

	if( uiY1 < uiY2 ){
		if( uiX1 < uiX2 ){
			fnLineX2(uiX1,uiY1,uiX2,uiY2,ucC);
		}
		if( uiX1 > uiX2 ){
			fnLineX3(uiX2,uiY2,uiX1,uiY1,ucC);
		}
		if( uiX1 == uiX2 ){
			fnPaintBox(uiX1,uiY1,uiX2,uiY2,ucC);
		}
	}
	if( uiY1 > uiY2 ){
		if( uiX1 < uiX2 ){
			fnLineX3(uiX1,uiY1,uiX2,uiY2,ucC);
		}
		if( uiX1 > uiX2 ){
			fnLineX2(uiX2,uiY2,uiX1,uiY1,ucC);
		}
		if( uiX1 == uiX2 ){
			fnPaintBox(uiX2,uiY2,uiX1,uiY1,ucC);
		}
	}
	if( uiY1 == uiY2 ){
		fnLineXA(uiY1,uiX1,uiX2,ucC);
	}
}

/*********************************************************************
	֐
		fnCircle
	
		(uiX1,uiY1) : S
		Rad : a
		ucC : F
	߂l
		Ȃ
	
		CӐFŉ~

**********************************************************************/
void	fnCircle(unsigned int uiX1,unsigned int uiY1,
				 unsigned int Radx,unsigned int Rady,unsigned char ucC)
{
	if( uiX1 >= Radx && uiY1 >= Rady ){
		if( Radx == 1 && Rady == 1){
			fnDot(uiX1,uiY1,ucC);
		}else if(Radx == 1){
			fnLine(uiX1,uiY1-Rady+1,uiX1,uiY1+Rady-2,ucC);
		}else if(Rady == 1){
			fnLine(uiX1-Radx+1,uiY1,uiX1+Radx-2,uiY1,ucC);
		}else{
		/*Rی*/
		_fnCircle( uiX1, uiY1, uiX1+1-Radx,uiY1,
			uiX1-(9659*Radx)/10000, uiY1-(Rady*2588)/10000,ucC );
		_fnCircle( uiX1, uiY1, uiX1-(9659*Radx)/10000, uiY1-(Rady*2588)/10000,
			uiX1-(8660*Radx)/10000, uiY1-(Rady*5000)/10000,ucC );
		_fnCircle( uiX1, uiY1, uiX1-(8660*Radx)/10000, uiY1-(Rady*5000)/10000,
			uiX1-(7071*Radx)/10000, uiY1-(Rady*7071)/10000,ucC );
		_fnCircle( uiX1, uiY1, uiX1-(7071*Radx)/10000, uiY1-(Rady*7071)/10000,
			uiX1-(5000*Radx)/10000, uiY1-(Rady*8660)/10000, ucC );
		_fnCircle( uiX1, uiY1, uiX1-(5000*Radx)/10000, uiY1-(Rady*8660)/10000,
			uiX1-(2588*Radx)/10000, uiY1-(Rady*9659)/10000, ucC) ;
		_fnCircle( uiX1, uiY1, uiX1-(2588*Radx)/10000, uiY1-(Rady*9659)/10000,
			uiX1, uiY1+1-Rady, ucC );
		}
	}
}

void _fnCircle(unsigned int uiX,unsigned int uiY,unsigned int uiX1,unsigned int uiY1,
			   unsigned int uiX2,unsigned int uiY2,unsigned char ucC)
{
	unsigned int tx,ty,x,y,xn,yn;

	tx = uiX2-uiX1+1;
	ty = uiY1-uiY2+1;
	if(tx == ty){
		for( ;uiX1 <= uiX2; uiX1++,uiY1--) {
			fnDot( uiX1,uiY1,ucC);
			fnDot( 2*uiX-uiX1, uiY1, ucC);
			fnDot( uiX1, 2*uiY-uiY1, ucC);
			fnDot( 2*uiX-uiX1, 2*uiY-uiY1, ucC);
		}
	}
	if(tx > ty){
		for( x=uiX1,y=1; uiX1 <= uiX2 ; uiX1++){
			xn = x + (tx * y) / ty;
			if(xn < uiX1) {
				uiY1--;
				y++;
			}
			fnDot( uiX1, uiY1, ucC);
			fnDot( 2*uiX-uiX1, uiY1, ucC);
			fnDot( uiX1, 2*uiY-uiY1, ucC);
			fnDot( 2*uiX-uiX1, 2*uiY-uiY1, ucC);
		}
	}
	if(tx < ty){
		for( x=1,y=uiY2; uiY2 <= uiY1 ; uiY2++){
			yn = y + (ty * x) / tx;
			if(yn < uiY2) {
				uiX2--;
				x++;
			}
			fnDot( uiX2, uiY2, ucC);
			fnDot( 2*uiX-uiX2, uiY2, ucC );
			fnDot( uiX2, 2*uiY-uiY2, ucC );
			fnDot( 2*uiX-uiX2, 2*uiY-uiY2, ucC );
		}
	}
}

/*********************************************************************
	֐
		fnCircleC
	
		(uiX1,uiY1) : S
		Rad : a
		ucC : F
	߂l
		Ȃ
	
		CӐFŉ~ihԂj

**********************************************************************/
void fnCircleC(unsigned int uiX1,unsigned int uiY1,unsigned int Radx,unsigned int Rady,unsigned char ucC)
{
	unsigned int i;
	for(i=1;i<=Radx;i++){ 
			fnCircle(uiX1,uiY1,i,Rady,ucC);
	}
}

/******************************
	֐
		fnLineX
	
		ay:̂W
		ac:hbg̕\F
	߂l
		Ȃ
	
		P{

*******************************/
void fnLineX( unsigned int ay, unsigned char ac )
{
/*	unsigned int uiAddress,tx;

	uiAddress = ay * LCD_LINEINT + LCD_OFFSET;
	for( tx = 0 ; tx < LCD_WIDTH ; tx++,uiAddress++){
		*(unsigned char *)uiAddress = ac;
	}
*/
	unsigned int tx;
	register unsigned char *adr ;

	adr = 	(unsigned char *)( ay * LCD_LINEINT + LCD_OFFSET) ;
#ifdef	USE_BANK
	if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif
	for( tx = 0 ; tx < LCD_WIDTH ; tx++){
		*adr++ = ac ;
	}
}

/******************************
	֐
		fnLineXA
	
		ay:̂W
		ac:hbg̕\F
	߂l
		Ȃ
	
		P{(͈͎wj

******************************/
void fnLineXA(unsigned int ay,unsigned int ax1,unsigned int ax2,unsigned char ac)
{
/*	unsigned int uiAddress,tx,ax3;

	if(ax1 > ax2){
		ax3 = ax1;
		ax1 = ax2;
		ax2 = ax3;
	}

	uiAddress = ay * LCD_LINEINT + ax1 + LCD_OFFSET;
	for( tx = ax1 ; tx <= ax2 ; tx++,uiAddress++){
		*(unsigned char *)uiAddress = ac;
	}
*/
	unsigned int tx, ax3 ;
	register unsigned char *adr ;

	if(ax1 > ax2){
		// swap
		ax3 = ax1;
		ax1 = ax2;
		ax2 = ax3;
	}

	adr = 	(unsigned char *)( ay * LCD_LINEINT + ax1 + LCD_OFFSET) ;
#ifdef	USE_BANK
	if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif
	for( tx = ax1 ; tx <= ax2 ; tx++){
		*adr++ = ac ;
	}
}

/******************************
	֐
		fnLineX2
	
		(uiX1,uiY1)
		(uiX2,uiY2)
		ucC : F
	߂l
		Ȃ
	
		CӐFŎΐ(Xj

******************************/
void	fnLineX2( unsigned int uiX1, unsigned int uiY1,
				  unsigned int uiX2, unsigned int uiY2, unsigned char ucC)
{
//	unsigned int tx,ty,x,y,xn,yn;
	unsigned short tx,ty,x,y ;
	unsigned int xn,yn;

	tx = uiX2-uiX1+1;
	ty = uiY2-uiY1+1;
	if(tx == ty){
		for(;uiX1 <= uiX2; uiX1++,uiY1++)
			fnDot(uiX1,uiY1,ucC);
	}
	if(tx > ty){
		for( x=uiX1,y=1; uiX1 <= uiX2 ; uiX1++ ){
			xn =  ( unsigned int )( x + (tx * y) / ty );	// 32bit*32bitƏd?
			if(xn < uiX1) {
				uiY1++;
				y++;
			}
			fnDot(uiX1,uiY1,ucC);
		}
	}
	if(tx < ty){
		for( x=1,y=uiY1; uiY1 <= uiY2 ; uiY1++ ){
			yn = ( unsigned int )( y + (ty * x) / tx );
			if(yn < uiY1) {
				uiX1++;
				x++;
			}
			fnDot(uiX1,uiY1,ucC);
		}
	}
}

/*****************************
	֐
		fnLineX3
	
		(uiX1,uiY1)
		(uiX2,uiY2)
		ucC : F
	߂l
		Ȃ
	
		CӐFŎΐiXj

******************************/
void fnLineX3( unsigned int uiX1, unsigned int uiY1,
			   unsigned int uiX2, unsigned int uiY2, unsigned char ucC )
{
	unsigned short tx,ty,x,y ;
	unsigned int xn,yn;
//	unsigned int tx,ty,x,y,xn,yn;

	tx = uiX2 - uiX1 +1;
	ty = uiY1 - uiY2 +1;
	if(tx == ty){
		for(;uiX1 <= uiX2; uiX1++,uiY1--)
			fnDot( uiX1, uiY1, ucC );
	}
	if(tx > ty){
		for(x=uiX1,y=1; uiX1 <= uiX2 ; uiX1++){
			xn = ( unsigned int )( x + (tx * y) / ty ) ;
			if(xn < uiX1) {
				uiY1--;
				y++;
			}
			fnDot( uiX1, uiY1, ucC );
		}
	}
	if(tx < ty){
		for( x=1,y=uiY2; uiY2 <= uiY1 ; uiY2++){
			yn = ( unsigned int )( y + (ty * x) / tx );
			if(yn < uiY2) {
				uiX2--;
				x++;
			}
			fnDot(uiX2,uiY2,ucC);
		}
	}
}


/*********************************************************************
	֐
		fnPaintBox
	
		(uiX1,uiY1)
		(uiX2,uiY2)
		ucC : F
	߂l
		Ȃ
	
		CӐFBOXh

**********************************************************************/
void fnPaintBox(unsigned int uiX1,unsigned int uiY1,unsigned int uiX2,
				unsigned int uiY2,unsigned char ucC )
{
/*	unsigned int uiAddress,tx,ty;

	for( ty = uiY1 ; ty <= uiY2 ; ty++ ){
		uiAddress = ty * LCD_LINEINT + uiX1 + LCD_OFFSET;
		for( tx = uiX1 ; tx <= uiX2 ; tx++,uiAddress++){
			*(unsigned char *)uiAddress = ucC;
		}
	}
*/
	unsigned int tx,ty;
	register unsigned char *adr ;

	for( ty = uiY1 ; ty <= uiY2 ; ty++ ){
		adr = 	(unsigned char *)( ty * LCD_LINEINT + uiX1 + LCD_OFFSET) ;
#ifdef	USE_BANK
		if ( adr > LCD_BANK0_END )	adr += LCD_BANK01_OFFSET ;
#endif
		for( tx = uiX1 ; tx <= uiX2 ; tx++ ){
			*adr++= ucC;
		}
	}
}


/*********************************************************************
	֐
		fnPaintBoxC
	
		(uiX1,uiY1)
		(uiX2,uiY2)
		ucC : FiEj
        ucD : FiEEj
	߂l
		Ȃ
	
		CӐFBOXijh

**********************************************************************/

void	fnPaintBoxC(unsigned int uiX1,unsigned int uiY1,
					unsigned int uiX2, unsigned int uiY2,
		unsigned char ucC, unsigned char ucD )
{
		fnLine(uiX1,uiY1,uiX1,uiY2,ucC);	/**/
		fnLine(uiX1,uiY1,uiX2,uiY1,ucC);	/**/
		fnLine(uiX2,uiY1,uiX2,uiY2,ucD);	/*E*/
		fnLine(uiX1,uiY2,uiX2,uiY2,ucD);	/**/
}


/*********************************************************************
	֐
		fn7seg_
	
		uiX,uiY   _X,YW(7seg̍Wj
		char@cPat	 \p^[
				bit0:a
				bit1:b
				bit2:c
				bit3:d
				bit4:e
				bit5:f
				bit6:g
		col		\F
		coloff	F
	߂l
		Ȃ
	
		ŐlnƁA17segp^[\
**********************************************************************/
void fn7seg_(unsigned int uiX,unsigned int uiY,
			 unsigned char cPat,unsigned char col,unsigned char coloff)
{
	unsigned char color;

	/* a */
	if(cPat & 0x01)		color = col;
	else				color = coloff;
		fnPaintBox( uiX+4, uiY, uiX+11, uiY+2, color);
		fnDot( uiX+ 3, uiY+1, color);
		fnDot( uiX+12, uiY+1, color);
	/* b */
	if(cPat & 0x02)		color = col;
	else				color = coloff;
		fnPaintBox( uiX+12, uiY+4, uiX+14, uiY+9, color);
		fnDot(uiX+13,uiY+ 3,color);
		fnDot(uiX+13,uiY+10,color);
	/* c */
	if(cPat & 0x04)		color = col;
	else				color = coloff;
		fnPaintBox(uiX+11,uiY+13,uiX+13,uiY+18,color);
		fnDot(uiX+12,uiY+12,color);
		fnDot(uiX+12,uiY+19,color);
	/* d */
	if(cPat & 0x08)		color = col;
	else				color = coloff;
		fnPaintBox(uiX+3,uiY+20,uiX+10,uiY+22,color);
		fnDot(uiX+ 2,uiY+21,color);
		fnDot(uiX+11,uiY+21,color);
	/* e */
	if(cPat & 0x10)		color = col;
	else				color = coloff;
		fnPaintBox(uiX+0,uiY+13,uiX+2,uiY+18,color);
		fnDot(uiX+1,uiY+12,color);
		fnDot(uiX+1,uiY+19,color);
	/* f */
	if(cPat & 0x20)		color = col;
	else				color = coloff;
		fnPaintBox(uiX+1,uiY+4,uiX+3,uiY+9,color);
		fnDot(uiX+2,uiY+ 3,color);
		fnDot(uiX+2,uiY+10,color);
	/* g */
	if(cPat & 0x40)		color = col;
	else				color = coloff;
		fnPaintBox(uiX+4,uiY+10,uiX+10,uiY+12,color);
		fnDot(uiX+ 3,uiY+11,color);
		fnDot(uiX+11,uiY+11,color);
}


/*********************************************************************
	֐
		fn7seg
	
		uiX,uiY   _X,YW(7seg̍Wj
		char@cPat	 \p^[
				bit0:a
				bit1:b
				bit2:c
				bit3:d
				bit4:e
				bit5:f
				bit6:g
		cColum	\  ő5܂
		col		 \F
	߂l
		Ȃ
	
		ŐlnƁAn7segp^[\
@@@@[TvX͖
		l菭Ȃ̏ꍇ́AElŃcWc}悤
		\B

**********************************************************************/
const unsigned char font7seg[16] = {0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};

#define PITCH7SEG 18

void fn7seg(unsigned int uiX,unsigned int uiY,int iValue,unsigned char cColum,unsigned char col,unsigned char coloff)
{
	unsigned int	uiDispStartX;
	int		iData;

	uiDispStartX = uiX - (5-cColum)*PITCH7SEG;
	iData = iValue;

	if(cColum >= 5)		
		fn7seg_(uiDispStartX,uiY,font7seg[iData/10000],col,coloff);
	else if((iData/10000)!=0)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/10000],col,coloff);

	iData = iData%10000;
	uiDispStartX+=PITCH7SEG;
	if(cColum >= 4)	
		fn7seg_(uiDispStartX,uiY,font7seg[iData/1000],col,coloff);
	else if((iData/1000)!=0)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/1000],col,coloff);

	iData = iData%1000;
	uiDispStartX+=PITCH7SEG;
	if(cColum >= 3)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/100],col,coloff);
	else if((iData/100)!=0)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/100],col,coloff);

	iData = iData%100;
	uiDispStartX+=PITCH7SEG;
	if(cColum >= 2)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/10],col,coloff);
	else if((iData/10)!=0)
		fn7seg_(uiDispStartX,uiY,font7seg[iData/10],col,coloff);

	iData = iData%10;
	uiDispStartX+=PITCH7SEG;
	fn7seg_(uiDispStartX,uiY,font7seg[iData],col,coloff);
}

