/*==============================================================================
	Copyright (C) 2008 IT Access.,Co.Ltd. All Rights Reserved.
	
	This software is the confidential and proprietary information 
	of IT Access.,Co.Ltd.
	
	Note:
			For NXP LPC2388 + Kenic 351 (KS-LETQ) without OS.
	
	2009/10 T.Kou IT-Access

==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> INCLUDE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/
/*
#include <stdlib.h>
#include <string.h>
*/
#include "stddef.h"

#include "GealTypes.h"

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> CONFIGURATION. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> TYPE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> MEMBER. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/
#ifndef	NULL
	#define	NULL	0
#endif

/*==============================================================================
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PROCEDURE. <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
==============================================================================*/
// memory֐Ȃ̂ŁAƎB 
#define	_NO_LM

#ifdef	_NO_LM

void *memcpy(void *s1, const void *s2, size_t n)
{
    char        *p1 = (char *)s1;
    const char  *p2 = (const char *)s2;

    while (n-- > 0) {
        *p1 = *p2;
        p1++;
        p2++;
    }
    return (s1);
}

void *memmove(void *s1, const void *s2, size_t n)
{
    char       *p1 = (char *)s1;
    const char *p2 = (const char *)s2;

    if (p1 < p2  &&  p1 < p2 + n)
        for (p1 += n, p1 += n; n > 0; n--)      /* 납Rs[ */
            *p1-- = *p2--;
    else
        for ( ; n > 0; n--)                     /* ORs[ */
            *p1++ = *p2++;

    return (s1);
}


void *memset(void *str, int c, size_t num)
{
    unsigned char *ptr = (unsigned char *)str;
    const unsigned char ch = c;
 
    while(num--)
        *ptr++ = ch;
 
    return str;
}

int memcmp(const void *s1, const void *s2, size_t n)
{
    const unsigned char  *p1 = (const unsigned char *)s1;
    const unsigned char  *p2 = (const unsigned char *)s2;

    while (n-- > 0) {
        if (*p1 != *p2)
            return (*p1 - *p2);
        p1++;
        p2++;
    }
    return (0);
}


#endif

/*------------------------------------------------------------------------------
	This API allocates memory.
------------------------------------------------------------------------------*/
GE_VOID* UGxAlloc( GE_UINT size )
{
	return NULL ;	// not using
//	return malloc(size);
}

/*------------------------------------------------------------------------------
	This API frees memory.
------------------------------------------------------------------------------*/
GE_VOID  UGxFree( GE_VOID *ptr )
{
//	free(ptr);
}

/*------------------------------------------------------------------------------
	This API moves memory.
------------------------------------------------------------------------------*/
GE_VOID* UGxMemmove(GE_VOID *dst, const GE_VOID *src, GE_UINT size)
{
	return memmove(dst, src, size);
}

/*------------------------------------------------------------------------------
	This API copies memory.
------------------------------------------------------------------------------*/
GE_VOID* UGxMemcpy(GE_VOID *dst, const GE_VOID *src, GE_UINT size)
{
	return memcpy(dst, src, size);
}

/*------------------------------------------------------------------------------
	This API sets data to memory.
------------------------------------------------------------------------------*/
GE_VOID* UGxMemset(GE_VOID *dst, GE_INT c, GE_UINT count )
{
	return memset(dst, c, count);
}

/*------------------------------------------------------------------------------
	This API compares the memory.
------------------------------------------------------------------------------*/
GE_INT   UGxMemcmp(const GE_VOID *dst, const GE_VOID *src, GE_UINT count )
{
	return memcmp(dst, src, count);
}

/*------------------------------------------------------------------------------
	This API gets current system ticks.
------------------------------------------------------------------------------*/
GE_UINT32 UGxGetTick()
{
	static GE_UINT32 cnt = 0 ;
//	struct timeval tv;
	
//	gettimeofday(&tv, NULL);
	
//	return tv.tv_sec * 1000 + tv.tv_usec / 1000;
	return ++cnt ;	// Temp	
	
}

/*------------------------------------------------------------------------------
	This API gets max value of system tick.
------------------------------------------------------------------------------*/
GE_UINT32 UGxGetTickMaxValue()
{
	return 0xFFFFFFFF;
}

/*------------------------------------------------------------------------------
	This API reserves the signal.
------------------------------------------------------------------------------*/
GE_VOID UGxReserveSignal(eGE_SIGNAL eSignal)
{

}

/*------------------------------------------------------------------------------
	This API releases the signal.
------------------------------------------------------------------------------*/
GE_VOID UGxReleaseSignal(eGE_SIGNAL eSignal)
{

}
